<?php
/*
|--------------------------------------------------------------------------
| admin.php 管理员表
|--------------------------------------------------------------------------
*/
# 定义几个常用的选项
$option = array
(
    1 => '启用',
    2 => '关闭',
);

$config = function()
{
    return Dever::load('manage/config-all');
};

return array
(
    # 表名
    'name' => 'help',
    # 显示给用户看的名称
    'lang' => '帮助管理',
    'order' => 6,
    # 数据结构
    'struct' => array
    (
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'list'      => true,
            'order'     => 'desc',
        ),
        
        'name'      => array
        (
            'type'      => 'varchar-32',
            'name'      => '帮助标题',
            'default'   => '',
            'desc'      => '请输入帮助标题',
            'match'     => 'is_string',
            'update'    => 'text',
            //'autocomplete' => 'auth.role?json=1',
            'search'    => 'order,fulltext',
            'list'      => true,
        ),
        
        'config'        => array
        (
            'type'      => 'int-11',
            'name'      => '后台配置',
            'default'   => '1',
            'desc'      => '请选择后台配置',
            'match'     => 'is_numeric',
            'option'    => $config,
            'update'    => 'select',
            'list'      => true,
        ),

        'reorder'       => array
        (
            'type'      => 'int-11',
            'name'      => '排序(数值越大越靠前)',
            'default'   => '1',
            'desc'      => '请输入排序',
            'match'     => 'option',
            'update'    => 'text',
            'search'    => 'order',
            'list'      => true,
            'order'     => 'desc',
        ),

        'video'     => array
        (
            'type'      => 'varchar-800',
            'name'      => '帮助视频-视频格式mp4，上传大小不能超过4G',
            'default'   => '',
            'desc'      => '帮助视频',
            'match'     => 'option',
            'update'    => 'video',
            'key'       => '3',
            'place'     => '150',
            'upload'    => 'yun',
            'large'     => true,
            //'cover'     => 'pic',//封面图字段名
        ),
        
        'content'       => array
        (
            'type'      => 'text-255',
            'name'      => '内容',
            'default'   => '',
            'desc'      => '请输入内容',
            'match'     => 'option',
            'update'    => 'editor',
            //'list'        => true,
            'key'       => 1,
        ),
        
        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
            
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '录入时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),
    
    'manage' => array
    (
        # 增加批量更新功能，根据哪个字段批量更新
        'update_mul' => 'name',
    ),
    
    # request 请求接口定义
    'request' => array
    (
        # 根据配置id获取notice
        'getAll' => array
        (
            # 匹配的正则或函数 必填项
            'where' => array
            (
                //'username' => '/^([A-Za-z0-9])/',
                'config' => 'yes',
                'state' => 1,
            ),
            'type' => 'all',
            'order' => array('id' => 'desc'),
            'limit' => '0,5',
            'col' => '*',
        ),
        
        # 根据配置id和notice Id获取
        'getOne' => array
        (
            'type' => 'one',
            'where' => array
            (
                'id' => 'yes',
                'config' => 'yes',
                'state' => 1,
            ),
            'input' => true,
        ),
    ),
);
